﻿//-----------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------
//--> ORIGINAL    by Nikos and Vagblad  -->  "DbfExcel.rar"
//--> CONTRIBUTED by Isma Elias y Leopoldo Blancas
//--> CONTRIBUTED by mustafa - Mustafa López
//--> CONTRIBUTED by SARGANTANA SOFT - José Manuel Carbonell
//--> CONTRIBUTED by andyglezl  - Andrés González López 
//--> MODULO : DBF to EXCEL 
//--> 07/05/2018 - V1.2 -> Revisión y ajustes, por fin tenemos fechas. jejejee
//-->  http://www.hmgforum.com/viewtopic.php?f=24&t=2822&hilit=dbf+excel&start=10
//-----------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------

#include <hmg.ch>

FUNCTION main()

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_CODEPAGE_ESWIN
  HB_SetCodePage("ESWIN")

  SET CENTURY ON
  SET DATE  BRITISH  
  SET ESCAPE ON

  SET LANGUAGE TO SPANISH 

  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
      
  SET TOOLTIPSTYLE BALLOON
*----------------------------------* 

   PRIVATE cArchivo := ''
   PRIVATE aTypeCol :={}
   PRIVATE nFilas   := 0
   PRIVATE nnColumn := 0
   
   PRIVATE aStruct
   PRIVATE nTotalReg 
   PRIVATE cDir   := GetCurrentFolder()  +"\" 
   PRIVATE nCampos, aCampos:={}
   PRIVATE ccFile := ''


  DEFINE WINDOW Main          ;
         AT 350 , 605         ;
         WIDTH 425 HEIGHT 295 ; 
         TITLE "Converter DBF -> Excel ->PDF  v 1.2  2018" ;
         ICON 'Logo'          ;   
         NOMAXIMIZE NOSIZE MAIN 
      
         ON KEY ESCAPE ACTION  Main.Release   
 
    DEFINE LABEL Label_1
        ROW    047
        COL    156 
        WIDTH  250
        HEIGHT 028
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
    END LABEL

    DEFINE LABEL Label_2
        ROW    085
        COL    020
        WIDTH  120
        HEIGHT 028
        VALUE "Excel FileName:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR Nil
        FONTCOLOR Nil
     END LABEL
 
     DEFINE LABEL Label_3
        ROW    140
        COL    159  
        WIDTH  250
        HEIGHT 028
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
    END LABEL

    DEFINE LABEL Label_4
        ROW    047
        COL    157 
        WIDTH  280
        HEIGHT 028
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_1
        ROW    082
        COL    155
        WIDTH  240 
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR { 251,221,251 }  
        DISABLEDFONTCOLOR Nil
        CASECONVERT NONE
        BACKCOLOR Nil
        FONTCOLOR Nil
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

    DEFINE  CHECKBOX Check_1
        ROW    166
        COL    159 
        WIDTH  150  
        CAPTION SPACE(3)+'Excel Pdf ?'       
        VALUE  .T.
        FONTNAME "Arial"
        FONTSIZE 9
        FONTBOLD .T.  
        FONTITALIC .F.  
        ONCHANGE CambiaXq()
    END CHECKBOX

    DEFINE BUTTON Button_1
        ROW    040
        COL    020
        WIDTH  110
        HEIGHT 028
        ACTION GetDbfFileName()
        CAPTION space(5)-"Select Dbf"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE  "Resource\Folder.bmp"
        PICTALIGNMENT LEFT               // TOP
    END BUTTON

    DEFINE BUTTON Button_2
        ROW    120
        COL    020
        WIDTH  110
        HEIGHT 028
        ACTION Export_Xls() 
        CAPTION space(5)-"Export File"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE  "Resource\Exel.bmp"
        PICTALIGNMENT LEFT            // TOP
    END BUTTON

    DEFINE BUTTON Button_3
        ROW    180
        COL    020
        WIDTH  110
        HEIGHT 028
        ACTION  Main.Release   
        CAPTION space(10)-"Exit"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "Resource\Cancel.bmp"
        PICTALIGNMENT LEFT            // TOP
    END BUTTON

 
 END WINDOW

    SETWINDOWCURSOR ( Main.Button_3.Handle , "Resource\finger.cur")

    Main.Label_3.Value := "Yes File Excel.Pdf" 

 Main.Center
 Main.Activate

Return

*------------------------------------------------------------------------*
 FUNCTION GetDbfFileName()
*------------------------------------------------------------------------*
   CLOSE DATABASES

   ccFile := UPPER(Getfile ( { {'Dbf Files','*.dbf'} } , 'Select File' , , .F. , .F., 1))

   IF ccFile < SPACE(1)
      MsgStop('Missing File','Attention !!!')
      Return Nil
   ENDIF

/*

     IF EMPTY(ccFile) .or. ccFile==NIL .or. LEN(ccFile)=0 .or. !file(ccFile)
        ccFile := getfile({{"Archivos excel  (*.DBF)","*.dbf"}},"Seleccione un archivo DBF",GetCurrentFolder(),.f.)
     endif

     if EMPTY(ccFile) .or. ccFile==NIL .or. LEN(ccFile)=0 .or. !file(ccFile)
        return nil
     endif
     
*/

      cArchivo := SUBSTR(ccFile,RAT("\",ccFile)+1) 
      cArchivo := SUBSTR(cArchivo,1,RAT(".",cArchivo)-1) 
      Main.Text_1.VALUE := LOWER(cArchivo ) + ".dbf"       
	
      USE &(cArchivo) ALIAS &(cArchivo) NEW
	
      aStruct := &(cArchivo)->(DBSTRUCT())

      nTotalReg := &(cArchivo)->(LASTREC())
      Main.Label_4.VALUE := "Registros:" +SPACE(2)+ alltrim(TRANSFORM(nTotalReg , "999,999,999") )
      &(cArchivo)->(DBGOTOP())

	
RETURN NIL

*------------------------------------------------------------------------*
STATIC PROCEDURE Export_Xls()  
*------------------------------------------------------------------------*

 LOCAL oExcel, oHoja, cCampo, i , eSta_1 ,  eSta_2

  Main.Check_1.Enabled  := .F.
  Main.Button_1.Enabled := .F.
  Main.Button_2.Enabled := .F.
  Main.Button_3.Enabled := .F.


    IF ccFile <= SPACE(1)
       MsgStop('Missing File','Attention !!!')
       Main.Check_1.Enabled  := .T.
       Main.Button_1.Enabled := .T.
       Main.Button_2.Enabled := .T.
       Main.Button_3.Enabled := .T.
     Return(.F.)
  ENDIF
*----------------------- Delete Dupli --------------------------
  eSta_1 := ( cDir + LOWER(cArchivo )+ ".xls" )           
  eSta_2 := ( cDir + LOWER(cArchivo )+ ".pdf" )          

  IF FILE(  eSta_1 ) .OR. FILE(  eSta_2 )
    FileDelete(  eSta_1 )
    FileDelete(  eSta_2 )
  ENDIF
*-----------------------------------------------------------------
   oExcel := CreateObject( "Excel.Application.12" )
   oExcel:WorkBooks:Add()
   oHoja := oExcel:ActiveSheet()
   oHoja:Cells:Font:Name := "Arial"
   oHoja:Cells:Font:Size := 10   
*-----------------------------------------------------------------
   oHoja:PageSetup:Zoom := .F.                //Fit all columns in one page, and page orientation to landscape
   oHoja:PageSetup:Orientation := 2 
   oHoja:PageSetup:FitToPagesTall := .F.
   oHoja:PageSetup:FitToPagesWide := 1 
*-----------------------------------------------------------------

    FOR n:=1 TO LEN(aStruct) STEP 1
		cCampo := aStruct[n][1]
		oHoja:Cells( 1,n ):Value := cCampo
    NEXT n
	
	&(cArchivo)->(DBGOTOP())

	i:=2
	DO WHILE !EOF()
	    FOR n:=1 TO LEN(aStruct) STEP 1
			cCampo := aStruct[n][1]
			oHoja:Cells( i,n ):Value := &(cArchivo)->&(cCampo)
		NEXT n
		&(cArchivo)->(DBSKIP())
		i:=i+1
	END DO
	Do Events
	
	WAIT CLEAR

    FOR n:=1 TO LEN(aStruct) STEP 1
		oHoja:Columns( n ):AutoFit()
    NEXT n

   oHoja:Cells( 1, 1 ):Select()
   oExcel:Visible := .F.  //  .T.

 CambiaXq()

   oExcel:ActiveWorkbook:SaveAs(cDir + LOWER(cArchivo )+ ".xls",-4143)           


*----------------------------- Create File PDF --------------------------*
IF aChecboQ = "True"   
   Main.Label_3.Value := " "
   Main.Label_3.Value := alltrim(LOWER(cArchivo + ".Pdf"))
*  Main.Label_4.VALUE := "Registros:" +SPACE(2)+ alltrim(TRANSFORM(nTotalReg , "999,999,999") )

   Main.Text_1.VALUE := LOWER(cArchivo ) + ".xls"   
   oHoja:Cells:Font:Name := "Arial"
   oHoja:Cells:Font:Size := 9  
   oExcel:ActiveWorkbook:ExportAsFixedFormat(0, cDir + LOWER(cArchivo) + ".pdf") 
ELSE 
    Main.Label_3.Value := " "
    Main.Label_3.Value  := "No File Excel.Pdf"
    Main.Text_1.VALUE := LOWER(cArchivo ) + ".xls"   
ENDIF
*------------------------------------------------------------------------*

  oExcel:DisplayAlerts := .F.
  oExcel:Quit() 
  oHoja := NIL
  oExcel := NIL
  Release oExcel
  Msginfo("Finished!!!","Done!")

  Main.Check_1.Enabled  := .T.
  Main.Button_1.Enabled := .T.
  Main.Button_2.Enabled := .T.
  Main.Button_3.Enabled := .T.

  CLOSE DATABASES
RETURN

*------------------------------------------------------------------------*
  FUNCTION   CambiaXq()
*------------------------------------------------------------------------*
   PUBLIC aChecboQ
   aChecboQ  := ( IIF(Main.Check_1.Value,"True","False") )
 
   IF aChecboQ = "True"   
      Main.Label_3.Value := "Yes File Excel.Pdf"
   ELSE
     Main.Label_3.Value  := "No File Excel.Pdf"
   ENDIF

RETURN NIL



*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*











